/******************************************************************************
   1) veld ca-qoutation_item_tariff.ind_active is hernoemd naar ca-quotation_item_tariff.ind_inactive
      nu waarde omzetten.
*******************************************************************************/

/*--indien al een keer uitgevoerd, dan overslaan --*/
IF CAN-FIND(FIRST sp-control WHERE
                  sp-control.controlkode EQ THIS-PROCEDURE:FILE-NAME )
THEN RETURN.


DEF VAR cProgram                      AS CHAR NO-UNDO.
DEF VAR cAction                       AS CHAR NO-UNDO.
DEF VAR cTable                        AS CHAR NO-UNDO.
DEF VAR iTotal                        AS INT  NO-UNDO.
DEF VAR iDone                         AS INT  NO-UNDO.
DEF VAR iModulo                       AS INT  NO-UNDO.

ASSIGN cProgram =  THIS-PROCEDURE:FILE-NAME
       cAction  = ''
       iModulo  =  100.  /* om de 100 records info tonen */

FORM 'Program  :' AT 1 cProgram   NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     'Action   :' AT 1 cAction    NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     'Table    :' AT 1 cTable     NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     'Total    :' AT 1 iTotal     NO-LABEL  FORMAT '9999999'  AT 12  SKIP
     'Done     :' AT 1 iDone      NO-LABEL  FORMAT '9999999'  AT 12  SKIP   
     WITH FRAME a.

&GLOBAL-DEFINE mydisplay cProgram cAction cTable iTotal iDone  WITH FRAME a

/*****************************************************************************************************
   EVEN TELLEN, 
*****************************************************************************************************/
cAction = 'Counting..' .
cTable  = 'CA-QUOTATION_ITEM_TARIFF'. 
DISPLAY {&mydisplay}.
FOR EACH ca-QUOTATION_ITEM_TARIFF NO-LOCK:
   iTotal = iTotal + 1.
   IF iTotal MODULO iModulo EQ 0 
   THEN DISPLAY {&mydisplay}.
END.

/*****************************************************************************************************
 MAIN BLOCK
 *****************************************************************************************************/
ASSIGN cTable  = 'CA-QUOTATION_ITEM_TARIFF'
       cAction = 'Swapping value ind_inactive'.
DISPLAY {&mydisplay}.

/*--ivm met performance triggers disablen --*/
DISABLE TRIGGERS FOR LOAD OF ca-quotation_item_tariff.

FOR EACH ca-quotation_item_tariff EXCLUSIVE-LOCK TRANSACTION:
   ASSIGN iDone                                 = iDone + 1
          ca-quotation_item_tariff.ind_inactive = NOT ca-quotation_item_tariff.ind_inactive.
   IF iDone MODULO iModulo EQ 0 
   THEN DISPLAY {&mydisplay}.
END. /*each */

/*****************************************************************************************************
     registreren voor toekomstige runs dat deze script al is uitgevoerd en kan worden overgeslagen
*****************************************************************************************************/
ASSIGN cTable  = ''
       cAction = 'Done...' .
DISPLAY {&mydisplay}.

DO TRANSACTION:
   CREATE sp-control.
   ASSIGN sp-control.controlkode = THIS-PROCEDURE:FILE-NAME
          sp-control.lijst       = 'uitgevoerd op ' + STRING(TODAY,'99-99-9999') + ' ' + STRING(TIME,'HH:MM:SS')
          sp-control.uitleg      = 'Swappen ca-quotation_item_tariff.ind_inactive wegens hernoemen van dit veld'.
END. /*transaction*/
                    

   
