&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12 GUI ADM2
&ANALYZE-RESUME
/* Connected Databases 
*/
&Scoped-define WINDOW-NAME CURRENT-WINDOW
&Scoped-define FRAME-NAME gDialog
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS gDialog 
CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */
/* Parameters Definitions ---                                           */
  &IF DEFINED(UIB_IS_RUNNING) EQ 0 
  &THEN          
     DEFINE INPUT        PARAMETER phWindow                  AS HANDLE    NO-UNDO.
  &ELSE
     DEF VAR phWindow                  AS HANDLE    NO-UNDO.
  &ENDIF  


{system/include/sp-AllObjects-def.i}
{CA/include/ca-allobjects-def.i}

/*---  ---
in het aanroepende object als volgt phWindow bepalen :
{get containerSource hContainerSource}.
hWindow = DYNAMIC-FUNCTION('spWindowHandle' IN hContainerSource). 
---  ---*/

/* Local Variable Definitions ---                                       */
DEF VAR gcLineCode AS CHAR   NO-UNDO.
DEFINE VARIABLE cDummyReturn AS CHARACTER NO-UNDO. /* Voor CA/edi/ca-edi-ifcsum-import-POFM.p is een output van error in ca-create-number.p nodig, voor overige aanroependeprogramma's als dummywaarde opnemen*/ 

DEFINE TEMP-TABLE tt-data NO-UNDO
   FIELD companycode          LIKE ca-u_shipment.companycode
   FIELD shipment_seqnr       LIKE ca-u_shipment.shipment_seqnr
   FIELD inout                AS CHARACTER FORMAT 'X(3)'  LABEL ''
   FIELD fieldname            AS CHARACTER FORMAT 'X(10)' LABEL 'Field'
   FIELD value_old            AS CHARACTER FORMAT 'X(25)' LABEL 'Old Value'
   FIELD value_new            AS CHARACTER FORMAT 'X(25)' LABEL 'New Value'
   .

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE SmartDialog
&Scoped-define DB-AWARE no

&Scoped-define ADM-CONTAINER DIALOG-BOX

&Scoped-define ADM-SUPPORTED-LINKS Data-Target,Data-Source,Page-Target

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME gDialog
&Scoped-define BROWSE-NAME brList

/* Internal Tables (found by Frame, Query & Browse Queries)             */
&Scoped-define INTERNAL-TABLES tt-data

/* Definitions for BROWSE brList                                        */
&Scoped-define FIELDS-IN-QUERY-brList inout fieldname value_old value_new   
&Scoped-define ENABLED-FIELDS-IN-QUERY-brList   
&Scoped-define SELF-NAME brList
&Scoped-define QUERY-STRING-brList FOR EACH tt-data
&Scoped-define OPEN-QUERY-brList OPEN QUERY {&SELF-NAME} FOR EACH tt-data.
&Scoped-define TABLES-IN-QUERY-brList tt-data
&Scoped-define FIRST-TABLE-IN-QUERY-brList tt-data


/* Definitions for DIALOG-BOX gDialog                                   */

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS vesselnr brList Btn_Cancel 
&Scoped-Define DISPLAYED-OBJECTS vesselnr fil-vesselnr 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD spSetFields gDialog 
FUNCTION spSetFields RETURNS LOGICAL
  ( pcField AS CHAR )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD spSetSens gDialog 
FUNCTION spSetSens RETURNS LOGICAL
  ( pcFields AS CHAR )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* ***********************  Control Definitions  ********************** */

/* Define a dialog box                                                  */

/* Definitions of the field level widgets                               */
DEFINE BUTTON btn-xref-vesselnr 
     IMAGE-UP FILE "system/media/btn-search-u":U
     IMAGE-DOWN FILE "system/media/btn-search-d":U
     IMAGE-INSENSITIVE FILE "system/media/btn-search-i":U NO-FOCUS
     LABEL "Btn 3" 
     SIZE 5.4 BY 1.19.

DEFINE BUTTON btnDeselectAll 
     LABEL "Deselect All" 
     SIZE 15 BY 1.14.

DEFINE BUTTON btnSelectAll 
     LABEL "Select All" 
     SIZE 15 BY 1.14.

DEFINE BUTTON Btn_Cancel AUTO-END-KEY 
     LABEL "Cancel" 
     SIZE 15 BY 1.14
     BGCOLOR 8 .

DEFINE BUTTON Btn_OK AUTO-GO 
     LABEL "OK" 
     SIZE 15 BY 1.14
     BGCOLOR 8 .

DEFINE VARIABLE fil-vesselnr AS CHARACTER FORMAT "X(256)":U 
     VIEW-AS FILL-IN 
     SIZE 30.6 BY 1 NO-UNDO.

DEFINE VARIABLE vesselnr AS CHARACTER FORMAT "X(256)":U 
     LABEL "Voyage" 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.

/* Query definitions                                                    */
&ANALYZE-SUSPEND
DEFINE QUERY brList FOR 
      tt-data SCROLLING.
&ANALYZE-RESUME

/* Browse definitions                                                   */
DEFINE BROWSE brList
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS brList gDialog _FREEFORM
  QUERY brList DISPLAY
      inout    
 fieldname
 value_old
 value_new
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SEPARATORS MULTIPLE SIZE 136.8 BY 15.24 FIT-LAST-COLUMN.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME gDialog
     btn-xref-vesselnr AT ROW 1.48 COL 37
     vesselnr AT ROW 1.48 COL 21.2 COLON-ALIGNED
     fil-vesselnr AT ROW 1.48 COL 39.8 COLON-ALIGNED NO-LABEL
     brList AT ROW 2.91 COL 2.8
     Btn_OK AT ROW 18.86 COL 20.8
     btnSelectAll AT ROW 18.86 COL 52
     btnDeselectAll AT ROW 18.86 COL 82.6
     Btn_Cancel AT ROW 18.86 COL 112
     SPACE(13.79) SKIP(0.56)
    WITH VIEW-AS DIALOG-BOX KEEP-TAB-ORDER 
         SIDE-LABELS NO-UNDERLINE THREE-D  SCROLLABLE 
         TITLE "Check and correct"
         DEFAULT-BUTTON Btn_OK CANCEL-BUTTON Btn_Cancel.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: SmartDialog
   Allow: Basic,Browse,DB-Fields,Query,Smart
   Container Links: Data-Target,Data-Source,Page-Target
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB gDialog 
/* ************************* Included-Libraries *********************** */

{system/super/sp-containr.i}
{ca/super/ca-super.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME




/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR DIALOG-BOX gDialog
   FRAME-NAME                                                           */
/* BROWSE-TAB brList fil-vesselnr gDialog */
ASSIGN 
       FRAME gDialog:SCROLLABLE       = FALSE
       FRAME gDialog:HIDDEN           = TRUE.

/* SETTINGS FOR BUTTON btn-xref-vesselnr IN FRAME gDialog
   NO-ENABLE                                                            */
ASSIGN 
       btn-xref-vesselnr:PRIVATE-DATA IN FRAME gDialog     = 
                "xref-partner=vesselnr".

/* SETTINGS FOR BUTTON btnDeselectAll IN FRAME gDialog
   NO-ENABLE                                                            */
/* SETTINGS FOR BUTTON btnSelectAll IN FRAME gDialog
   NO-ENABLE                                                            */
/* SETTINGS FOR BUTTON Btn_OK IN FRAME gDialog
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN fil-vesselnr IN FRAME gDialog
   NO-ENABLE                                                            */
ASSIGN 
       fil-vesselnr:PRIVATE-DATA IN FRAME gDialog     = 
                "xref-partner=vesselnr,xref-field=des".

ASSIGN 
       vesselnr:PRIVATE-DATA IN FRAME gDialog     = 
                "Xref-table=aa-vessel,Xref-codefield=vesselnr,Xref-filtervalues=no,spSetSens=yes,spSetFields=yes".

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE brList
/* Query rebuild information for BROWSE brList
     _START_FREEFORM
OPEN QUERY {&SELF-NAME} FOR EACH tt-data.
     _END_FREEFORM
     _Query            is NOT OPENED
*/  /* BROWSE brList */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK DIALOG-BOX gDialog
/* Query rebuild information for DIALOG-BOX gDialog
     _Options          = "SHARE-LOCK"
     _Query            is NOT OPENED
*/  /* DIALOG-BOX gDialog */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME gDialog
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL gDialog gDialog
ON WINDOW-CLOSE OF FRAME gDialog /* Check and correct */
DO:  
  /* Add Trigger to equate WINDOW-CLOSE to END-ERROR. */
  APPLY "END-ERROR":U TO SELF.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME brList
&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK gDialog 


/* ***************************  Main Block  *************************** */
&IF DEFINED(UIB_IS_RUNNING) EQ 0 
&THEN 
   FRAME {&FRAME-NAME}:PARENT = phWindow.
&ENDIF

{adm2/dialogmn.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-create-objects gDialog  _ADM-CREATE-OBJECTS
PROCEDURE adm-create-objects :
/*------------------------------------------------------------------------------
  Purpose:     Create handles for all SmartObjects used in this procedure.
               After SmartObjects are initialized, then SmartLinks are added.
  Parameters:  <none>
------------------------------------------------------------------------------*/

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE caFillTempTable gDialog 
PROCEDURE caFillTempTable :
RUN caFindOutward.
   RUN caFindInward.
   
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE caFindInward gDialog 
PROCEDURE caFindInward :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
   DEFINE VARIABLE cValues AS CHARACTER   NO-UNDO.
   
   FOR EACH ca-i_shipment WHERE
            ca-i_shipment.companycode EQ sp-companycode
        AND ca-i_shipment.linecode    EQ gcLineCode
        AND ca-i_shipment.vesselnr    EQ INT(vesselnr:SCREEN-VALUE IN FRAME {&FRAME-NAME})
            NO-LOCK:
      RUN ca/proc/ca-create-number.p (INPUT 'T',INPUT 'BL',INPUT BUFFER ca-i_shipment:HANDLE,INPUT NO,INPUT NO,INPUT-OUTPUT cValues,OUTPUT cDummyReturn).
      
      IF ca-i_shipment.bl-number EQ spGetEntry('bl-number',cValues,CHR(1),CHR(1)) 
      THEN NEXT.
      
      CREATE tt-data.
      ASSIGN tt-data.companycode    = ca-i_shipment.companycode
             tt-data.shipment_seqnr = ca-i_shipment.shipment_seqnr
             tt-data.inout          = 'In'
             tt-data.fieldname      = 'BL number'
             tt-data.value_old      = ca-i_shipment.bl-number
             tt-data.value_new      = spGetEntry('bl-number',cValues,CHR(1),CHR(1)).
   END. /*each i_shipment*/
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE caFindOutward gDialog 
PROCEDURE caFindOutward :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
   DEFINE VARIABLE cValues AS CHARACTER   NO-UNDO.
   
   FOR EACH ca-u_shipment WHERE
            ca-u_shipment.companycode EQ sp-companycode
        AND ca-u_shipment.linecode    EQ gcLineCode
        AND ca-u_shipment.vesselnr    EQ INT(vesselnr:SCREEN-VALUE IN FRAME {&FRAME-NAME})
            NO-LOCK:
      RUN ca/proc/ca-create-number.p (INPUT 'T',INPUT 'BK',INPUT BUFFER ca-u_shipment:HANDLE,INPUT NO,INPUT NO,INPUT-OUTPUT cValues,OUTPUT cDummyReturn).
      RUN ca/proc/ca-create-number.p (INPUT 'T',INPUT 'BL',INPUT BUFFER ca-u_shipment:HANDLE,INPUT NO,INPUT NO,INPUT-OUTPUT cValues,OUTPUT cDummyReturn).
      
      IF ca-u_shipment.bookingnr NE spGetEntry('bookingnr',cValues,CHR(1),CHR(1))
      THEN DO:
         CREATE tt-data.
         ASSIGN tt-data.companycode    = ca-u_shipment.companycode
                tt-data.shipment_seqnr = ca-u_shipment.shipment_seqnr
                tt-data.inout          = 'Out'
                tt-data.fieldname      = 'Bookingnr'
                tt-data.value_old      = ca-u_shipment.bookingnr
                tt-data.value_new      = spGetEntry('bookingnr',cValues,CHR(1),CHR(1)) .
      END.
      
      IF ca-u_shipment.bl-number NE spGetEntry('bl-number',cValues,CHR(1),CHR(1)) 
      THEN DO:
         CREATE tt-data.
         ASSIGN tt-data.companycode    = ca-u_shipment.companycode
                tt-data.shipment_seqnr = ca-u_shipment.shipment_seqnr
                tt-data.inout          = 'Out'
                tt-data.fieldname      = 'BL number'
                tt-data.value_old      = ca-u_shipment.bl-number
                tt-data.value_new      = spGetEntry('bl-number',cValues,CHR(1),CHR(1)) .
      END.
   END. /*each u_shipment*/
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI gDialog  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME gDialog.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI gDialog  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY vesselnr fil-vesselnr 
      WITH FRAME gDialog.
  ENABLE vesselnr brList Btn_Cancel 
      WITH FRAME gDialog.
  VIEW FRAME gDialog.
  {&OPEN-BROWSERS-IN-QUERY-gDialog}
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initializeObject gDialog 
PROCEDURE initializeObject :
/*------------------------------------------------------------------------------
  Purpose:     Super Override
  Parameters:  
  Notes:       
------------------------------------------------------------------------------*/

   /* Code placed here will execute PRIOR to standard behavior. */
   ASSIGN gcLineCode = getLineCode().
   
   RUN SUPER.

   /* Code placed here will execute AFTER standard behavior.    */
   
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

/* ************************  Function Implementations ***************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION spSetFields gDialog 
FUNCTION spSetFields RETURNS LOGICAL
  ( pcField AS CHAR ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/
  CASE pcField:
     WHEN 'vesselnr' 
     THEN DO WITH FRAME {&FRAME-NAME}: 
        ETIME(YES).
        RUN caFillTempTable.
        MESSAGE 'time to fill:' ETIME / 1000 's'.
        {&OPEN-QUERY-{&BROWSE-NAME}} 
     END.
  END CASE.
   
  RETURN YES.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION spSetSens gDialog 
FUNCTION spSetSens RETURNS LOGICAL
  ( pcFields AS CHAR ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/
   DEF VAR iField AS INT    NO-UNDO.
   
   DO WITH FRAME {&FRAME-NAME}:
      DO iField = 1 TO NUM-ENTRIES(pcFields):
         CASE ENTRY(iField,pcFields):
            WHEN 'vesselnr' 
            THEN ASSIGN lTmp = CAN-FIND(FIRST ca-u_shipment WHERE
                                              ca-u_shipment.companycode EQ sp-companycode
                                          AND ca-u_shipment.linecode    EQ gcLineCode
                                          AND ca-u_shipment.vesselnr    EQ INT(vesselnr:SCREEN-VALUE) )
                        Btn_OK        :SENSITIVE = lTmp
                        btnDeselectAll:SENSITIVE = lTmp
                        btnSelectAll  :SENSITIVE = lTmp .                
                                       
         END CASE.
      END. /*iField*/
   END. /*frame*/
   
   RETURN YES.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

